\ arithmetic
: scm-%+ ( n1 w2 -- n )
    scm-assert-inum scm-inum@ + ;

: scm.+ ( wenv wargs -- wresult )
    0 swap ['] scm-%+ scm-for-each scm-make-inum nip ;

: scm-%- ( n1 w2 -- n )
    scm-assert-inum scm-inum@ - ;

: scm.- ( wenv wargs -- wresult )
    scm-pair@ scm-assert-inum scm-inum@ swap
    ['] scm-%- scm-for-each scm-make-inum nip ;

: scm-%* ( n1 w2 -- n )
    scm-assert-inum scm-inum@ * ;

: scm.* ( wenv wargs -- wresult )
    1 swap ['] scm-%* scm-for-each scm-make-inum nip ;

: scm-%/ ( n1 w2 -- n )
    scm-assert-inum scm-inum@ / ;

: scm./ ( wenv wargs -- wresult )
    scm-pair@ scm-assert-inum scm-inum@ swap
    ['] scm-%/ scm-for-each scm-make-inum nip ;


: scm.< ( wenv wargs -- wresult )
    nip
    dup scm-list-length 2 <>
    s" invalid number of args for comparison" exception and throw
    scm-pair@ scm-assert-inum scm-inum@
    swap scm-car@ scm-assert-inum scm-inum@
    swap < if
	scm-bool-t
    else
	scm-bool-f
    endif ;

\ : scm.> ( wenv wargs -- wresult )
\    scm-reverse scm.< ;

\ arch-tag: 07bd08d7-5042-4b5c-94d9-a181f76bbf2c
\ (do not remove this comment)
